<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, question-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item search-item-width-100" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="difficulty" name="difficulty" lay-filter="difficultyFilter">
                                <option value="">选择难度</option>
                                <option value="1">⭐</option>
                                <option value="2">⭐⭐</option>
                                <option value="3">⭐⭐⭐</option>
                                <option value="4">⭐⭐⭐⭐</option>
                                <option value="5">⭐⭐⭐⭐⭐</option>
                            </select>
                        </div>
                        <div class="layui-inline">
                            <input type="hidden" id="questionType" readonly style="cursor: pointer;">
                            <input type="text" id="questionTypeName" class="layui-input search-item search-item-width-100" placeholder="试题类型" readonly style="cursor: pointer;">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                        <button type="button" id="saveBtn" class="layui-btn layui-btn-normal layui-btn-sm" style="float: right;">确定</button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var laytpl = layui.laytpl;
        var common = layui.common;
        var form = layui.form;
        var resizeTimeout = null;
        var queryParams = top.restAjax.params(window.location.href);
        var paperId = queryParams.paperId;
        var selectCount = queryParams.selectCount;
        var questionType = queryParams.questionType;
        var questionChoiceType = queryParams.questionChoiceType;

        var tableUrl = 'api/paper/question/listpage-question/exclude-paper-id/{paperId}?type={questionType}&choiceType={questionChoiceType}';

        var selectObj = {};

        function getDifficulty(num) {
            var result = '';
            for(var i = 0; i < num; i++) {
                result += '⭐'
            }
            return result;
        }

        // 初始化表格
        function initTable() {
            $.extend(table, {config: {checkName: 'checked'}});
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, [paperId, questionType, questionChoiceType]),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 60,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'subject', width: 400, title: '题目', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionTypeName', width: 140, title: '试题类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'difficulty', width: 150, title: '难度', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return getDifficulty(rowData);
                            }
                        },
                        {field: 'source', width: 150, title: '来源', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'gmtCreate', width: 180, title: '添加时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'getQuestion', width: 100, title: '详情', fixed: 'right', align:'center', exportType: 'text',
                            templet: function(row) {
                                return '<button class="layui-btn layui-btn layui-btn-sm layui-btn-normal" lay-event="getQuestionEvent"><i class="fa fa-search"></i> 查看</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    for(var i = 0, item; item = data.rows[i++];) {
                        if(selectObj[item.questionId]) {
                            item.checked = true;
                        } else {
                            item.checked = false;
                        }
                    }
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val(),
                    type: $('#type').val(),
                    choiceType: $('#choiceType').val(),
                    questionType: $('#questionType').val(),
                    difficulty: $('#difficulty').val()
                },
                page: {
                    curr: currentPage
                },
            });
        }
        initTable();

        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        table.on('checkbox(dataTable)', function(obj) {
            if(obj.type === 'one') {
                if(obj.checked) {
                    if(selectObj.length >= selectCount) {
                        obj.checked = !obj.checked;
                        top.dialog.msg('超过最大可选数量：'+ selectCount);
                        return;
                    }
                    selectObj[obj.data.questionId] = obj.data;
                } else {
                    delete selectObj[obj.data.questionId];
                }
            } else {
                var datas = table.cache.dataTable;
                if(obj.checked) {
                    for(var i = 0, item; item = datas[i++];) {
                        if(selectObj.length >= selectCount) {
                            obj.checked = !obj.checked;
                            top.dialog.msg('超过最大可选数量：'+ selectCount);
                            return;
                        }
                        selectObj[item.questionId] = item;
                    }
                } else {
                    for(var i = 0, item; item = datas[i++];) {
                        delete selectObj[item.questionId];
                    }
                }
            }
        });

        $(document).on('click', '#saveBtn', function() {
            var selectIdArray = [];
            for(var k in selectObj) {
                selectIdArray.push(k);
            }
            if(selectIdArray.length === 0) {
                top.dialog.msg('请选择试题');
                return;
            }
            top.dialog.confirm('确定保存吗？', function(index) {
                top.dialog.close(index);
                var loadLayerIndex;
                top.restAjax.post(top.restAjax.path('api/paper/question/save/paper-id/{paperId}', [paperId]), {
                    ids: selectIdArray
                }, null, function(code, data) {
                    top.dialog.msg('提交成功');
                    reloadTable(1);
                }, function(code, data) {
                    top.dialog.msg(data.msg);
                }, function() {
                    loadLayerIndex = top.dialog.msg('正在提交...', {icon: 16, time: 0, shade: 0.3});
                }, function() {
                    top.dialog.close(loadLayerIndex);
                });
            });
        })


        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'getQuestionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/question/get?questionId={questionId}', [data.questionId]),
                    title: '查看试题，难度：' + getDifficulty(data.difficulty),
                    width: '500px',
                    height: '80%',
                    onClose: function() {
                    }
                });
            }
        });

        form.on('select(typeFilter)', function(data){
            $('#choiceType').val('')
            form.render('select');
            if(data.value === 'choice') {
                $('#choiceTypeBox').show();
            } else {
                $('#choiceTypeBox').hide();
            }
        });

        $('#questionTypeName').on('click', function() {
            top.dialog.open({
                url: top.restAjax.path('route/question-type/list-tree-select?questionTypeIds={questionTypeIds}', [$('#questionType').val()]),
                title: '选择自定义类型',
                width: '200px',
                height: '400px',
                onClose: function() {
                    var selectedNodes = top.dialog.dialogData.selectedNodes;
                    if(selectedNodes.length > 0) {
                        var questionType = '';
                        var questionTypeName = '';
                        for(var i = 0, item; item = selectedNodes[i++];) {
                            if(questionType.length > 0) {
                                questionType += ',';
                                questionTypeName += ',';
                            }
                            questionType += item.id;
                            questionTypeName += item.name;
                        }
                        $('#questionType').val(questionType);
                        $('#questionTypeName').val(questionTypeName);
                    } else {
                        $('#questionType').val('');
                        $('#questionTypeName').val('');
                    }
                }
            });
        });
    });
</script>
</body>
</html>